SystemOrganization addCategory: #'Glamour-Tools'!

!GLMPresentation methodsFor: '*glamour-tools' stamp: 'TudorGirba 7/10/2011 00:50'!
viewNestedOn: view
	view shape label text: [:each | each class name removePrefix: 'GLM'].
	view node: self! !

!GLMBrowser methodsFor: '*glamour-tools' stamp: 'TudorGirba 4/22/2012 22:23'!
openTree
	| composer |
	composer := GLMCompositePresentation new.
	composer 
		act: [:b | b update] 
		icon: GLMUIThemeExtraIcons glamorousRefresh 
		entitled: 'Update'.
	composer tabulator with: [:t | 
		t column: #theOne.
		t transmit to: #theOne; andShow: [:a | 
			a mondrian 
				updateOn: GLMTransmissionTriggered from: [ self announcer ];
				painting: [:view :b | self viewTreeOn: view ] ]].
	composer openOn: self! !

!GLMBrowser methodsFor: '*glamour-tools' stamp: 'tg 5/18/2010 13:50'!
screenshot: aFilenameString on: anObject after: aBlock
	 
	| window |
	window := self openOn: anObject.
	aBlock glamourValue: self asGlamorousMultiValue.
	World doOneCycle.
	PNGReadWriter putForm: window imageForm onFileNamed: aFilenameString.
	^ window! !

!GLMBrowser methodsFor: '*glamour-tools' stamp: 'TudorGirba 10/8/2011 21:52'!
viewAnnouncements
	| view |
	view := MOViewRenderer new.
	self viewAnnouncementsOn: view.
	view open! !

!GLMBrowser methodsFor: '*glamour-tools' stamp: 'TudorGirba 7/14/2011 15:37'!
viewAnnouncementsOn: view
	view shape rectangle withoutBorder.
	view node: 'Glamour' forIt: [
		self viewTreeOn: view ].
	view shape umlClassWithTitle: #yourself.
	view node: 'Announced objects' forIt: [
		view shape label text: [:p | (p class name removePrefix: 'GLM') removeSuffix: 'Renderer' ].
		view nodes: 
			(self pane withAllPanes flatCollect: [:each | 
			each glmSubscriptions collect: [:eachSub | eachSub subscriber]]) asSet.
		view shape label text: [:p | (p class name removePrefix: 'GLM') removeSuffix: 'Renderer' ].
		view nodes: 
			(self pane withAllPresentations flatCollect: [:each | 
			each glmSubscriptions collect: [:eachSub | eachSub subscriber]]) asIdentitySet.
		view verticalLineLayout ].
	
	view shape line 
			color: Color red twiceLighter;
			fromPositions: #(rightCenter);
			toPositions: #(leftCenter).
	view edges: self pane withAllPanes from: #yourself toAll: [:each | 
			each glmSubscriptions collect: [:eachSub | eachSub subscriber]].
	view shape line 
			color: Color red twiceLighter;
			fromPositions: #(rightCenter);
			toPositions: #(leftCenter).
	view edges: self pane withAllPresentations from: #yourself toAll: [:each | 
			each glmSubscriptions collect: [:eachSub | eachSub subscriber]].
	view horizontalLineLayout horizontalGap: 50! !

!GLMBrowser methodsFor: '*glamour-tools' stamp: 'TudorGirba 7/10/2011 00:50'!
viewNestedOn: view
	view shape umlClassWithTitle: #name.
	view nodes: self panes forEach: [:each |
		view node: each ports forIt: [
			view shape label text: #name.
			view nodes: each ports.
			view verticalLineLayout gapSize: 2 ].
		view node: each presentations forIt: [
			view shape umlClassWithTitle: [:eachPresentation | eachPresentation class name removePrefix: 'GLM'].
	"		view shape label text: [:p | (p class name removePrefix: 'GLM') removeSuffix: 'Presentation' ]."
			each presentations presentations do: [:eachPresentation | 
				eachPresentation viewNestedOn: view ].
			view verticalLineLayout gapSize: 2 ].
		view verticalLineLayout gapSize: 0; stretch ].
	view 
		edges: self transmissions 
		fromAll: #origins
		to: #destination! !

!GLMBrowser methodsFor: '*glamour-tools' stamp: 'DamienCassou 7/24/2011 11:27'!
viewSketch

	| view |
	
	view := MOViewRenderer new.
	self viewSketchOn: view.
	view openWithStatusbar! !

!GLMBrowser methodsFor: '*glamour-tools' stamp: 'DamienCassou 7/24/2011 12:04'!
viewSketchOn: view
	| simpleName viewBrowser allTransmissions inTransmission|
	simpleName := [ :each | (each class name removePrefix: 'GLM') removeSuffix: 'Presentation' ].
	allTransmissions := (self withAllPresentations select: [ :each | each isKindOf: GLMBrowser ]) flatCollect: #transmissions.
	inTransmission := [:port | allTransmissions anySatisfy: [:tr | (tr origins includes: port) or: [tr destination = port]]].
	viewBrowser := [ :browser | 
	view shape umlClassWithTitle: simpleName.
	view
		node: browser
		forIt: [ 
			view
				nodes: browser panes
				forEach: [ :inPane | 
					view nodes: (inPane ports select: inTransmission).
					view shape label text: simpleName.
					view
						nodes: inPane presentations presentations
						forEach: [ :inPresentation | 
							(inPresentation isKindOf: GLMBrowser)
								ifTrue: [ viewBrowser value: inPresentation ] ] ].
			((browser isKindOf: GLMTabulator) and: [ browser cell isSplitIntoRows ])
				ifTrue: [ view verticalLineLayout gapSize: 2 ] ] ].
	viewBrowser value: self.
	view shape line color: Color blue.
	view edges: allTransmissions fromAll: #origins to: #destination! !

!GLMBrowser methodsFor: '*glamour-tools' stamp: 'TudorGirba 7/15/2011 13:13'!
viewTree

	| view |
	
	view := MOViewRenderer new.
	self viewTreeOn: view.
	view openWithStatusbar! !

!GLMBrowser methodsFor: '*glamour-tools' stamp: 'TudorGirba 7/10/2011 12:16'!
viewTreeOn: view
	| edges1 edges2 edges3 edges4 |
	
	view shape umlClassWithTitle: #name.
	view nodes: self pane withAllPanes forEach: [ :each |
		view shape label text: #name.
		view nodes: each ports.
		view verticalLineLayout gapSize: 2 ].
	
	view shape label text: [:p | (p class name removePrefix: 'GLM') removeSuffix: 'Presentation' ].
	view nodes: self pane withAllPresentations.

	view shape verticalOrthogonalLine color: Color lightGray. 	
	edges1 := view edges: self pane withAllPanes from: #yourself to: [:each | each presentations ].

	view shape verticalOrthogonalLine color: Color lightGray. 
	edges2 := view edges: self pane withAllPanes from: #browser to: #yourself.

	view shape verticalOrthogonalLine color: Color lightGray. 
	edges3 := view edges: (self pane withAllPresentations select: [:each | each isKindOf: GLMDynamicPresentation]) from: #yourself to: #cachedPresentation.

	view shape verticalOrthogonalLine color: Color lightGray.
	edges4 := view edges: (self pane withAllPresentations select: [:each | each isKindOf: GLMCompositePresentation]) from: #yourself toAll: #presentations.


	view treeLayout layered userDefinedEdges: (edges1, edges2, edges3, edges4).

	view shape line color: Color blue. 
	view 
		edges: ((self pane withAllPresentations select: [:each | each isKindOf: GLMBrowser]) flatCollect: [:each | each transmissions])
		fromAll: #origins
		to: #destination.
		view shape line color: Color blue
! !

Object subclass: #GLMBrowserTemplate
	instanceVariableNames: 'browser'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Tools'!

!GLMBrowserTemplate classSide methodsFor: 'opening' stamp: 'tg 12/29/2009 03:33'!
openOn: anEntity
	^ self new openOn: anEntity! !

!GLMBrowserTemplate classSide methodsFor: 'opening' stamp: 'tg 1/15/2010 23:46'!
startOn: anEntity
	^ self new startOn: anEntity! !

!GLMBrowserTemplate methodsFor: 'accessing' stamp: 'tg 12/29/2009 03:41'!
browser
	^ browser ifNil: [self buildBrowser. browser]! !

!GLMBrowserTemplate methodsFor: 'building' stamp: 'tg 12/15/2009 13:54'!
buildBrowser
	^ self subclassResponsibility! !

!GLMBrowserTemplate methodsFor: 'opening' stamp: 'tg 12/29/2009 03:30'!
openOn: anEntity
	^ self browser openOn: anEntity! !

!GLMBrowserTemplate methodsFor: 'opening' stamp: 'tg 1/15/2010 23:31'!
startOn: anEntity
	^ self browser startOn: anEntity! !

GLMBrowserTemplate subclass: #GLMGlobalBrowserTemplate
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Tools'!

!GLMGlobalBrowserTemplate classSide methodsFor: 'opening' stamp: 'tg 12/29/2009 03:31'!
open
	^ self new
		open! !

!GLMGlobalBrowserTemplate methodsFor: 'opening' stamp: 'tg 12/29/2009 03:31'!
entity
	^ self subclassResponsibility! !

!GLMGlobalBrowserTemplate methodsFor: 'opening' stamp: 'tg 12/29/2009 03:31'!
open
	^ self openOn: self entity! !

GLMBrowserTemplate subclass: #GLMScriptingEditorTemplate
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Tools'!

!GLMScriptingEditorTemplate commentStamp: 'TudorGirba 12/28/2011 23:33' prior: 0!
GLMScriptingEditorTemplate offers a simple template for building scripting editors.

It offers basically three panes:
- one for the script
- one for the set of input variables
- one for the preview once you accept the script

A typical case is provided by the GLMMondrianEasel.

To open any of the subclasses, you need to provide an array of associations whose values represent the names of a variables and the values are the objects referred by these variables. These variables can then be used in the code of the script.!

GLMScriptingEditorTemplate subclass: #GLMEditor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Tools'!

!GLMEditor commentStamp: 'TudorGirba 12/28/2011 23:33' prior: 0!
This is an Glamour-based editor for Glamour browsers.

Example:
self openOn: {#variable->'value'}

This will open the editor with a variable named #variable whose value will be 'value'.!

!GLMEditor methodsFor: 'private' stamp: 'TudorGirba 10/23/2011 22:44'!
createResultBrowserWithBindings: bindings andScript: script
	| context resultBrowser scriptedBrowser composer |
	composer := GLMCompositePresentation new.
	context := GLMContext with: #composer -> composer withAll: bindings.
	Compiler new evaluate: script in: context to: context.
	scriptedBrowser := composer first.
	resultBrowser := GLMTabulator new.
	resultBrowser column: #theOuterPane.
	resultBrowser transmit
		fromOutsideEntityPort; 
		to: #theOuterPane;
		andShow: [:a | 
			a custom: scriptedBrowser ].
	"this is a bit of a hack.
	we take the entity as specified in the script by taking it directly
	from the evaluated script browser.
	this is needed because right now the input entity is specified 
	in the same script with the browser"
	^ resultBrowser startOn: composer entity! !

!GLMEditor methodsFor: 'building' stamp: 'TudorGirba 10/8/2011 19:51'!
defaultScriptBindings
	^ {#composer -> GLMCompositePresentation new}! !

!GLMEditor methodsFor: 'building' stamp: 'TudorGirba 6/1/2012 20:13'!
defaultScriptDisplayIn: aTextPresentation
	^ aTextPresentation 
		display: 'composer';
		morphicAct: [:text | GLMBasicExamples open ] icon: GLMUIThemeExtraIcons glamorousExample entitled: 'Browse basic examples'! !

!GLMEditor methodsFor: 'building' stamp: 'TudorGirba 9/5/2011 19:04'!
defaultTitle
	^ 'Glamorous Browser Editor'! !

!GLMEditor methodsFor: 'building' stamp: 'TudorGirba 5/24/2012 17:20'!
resultIn: composite
	composite dynamic
		title: 'Preview';
		display: [ :bindings :script | self createResultBrowserWithBindings: bindings andScript: script ];
		act: [ :dynamic | 
				dynamic cachedPresentation presentations first panes first presentations first openTree ] 
			entitled: 'View browser tree';
		act: [:dynamic | dynamic cachedPresentation presentations first panes first presentations first explore ]
			icon: GLMUIThemeExtraIcons glamorousInspect
			entitled: 'Explore';
		act: [ :dynamic | 
				dynamic cachedPresentation presentations first panes first presentations first open ] 
			icon: GLMUIThemeExtraIcons glamorousSpawn
			entitled: 'Spawn browser'! !

GLMScriptingEditorTemplate subclass: #GLMEyeSeeEditor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Tools'!

!GLMEyeSeeEditor commentStamp: 'TudorGirba 12/28/2011 23:34' prior: 0!
This browser offers a Glamour-based editor for EyeSee charts.

Example:
self openOn: {#variable->'value'}

This will open the editor with a variable named #variable whose value will be 'value'.!

!GLMEyeSeeEditor methodsFor: 'building' stamp: 'TudorGirba 10/8/2011 19:57'!
defaultScriptBindings
	^ {#chart -> ESDiagramRenderer new}! !

!GLMEyeSeeEditor methodsFor: 'building' stamp: 'TudorGirba 9/9/2012 02:55'!
defaultScriptDisplayIn: aPresentation
	^ aPresentation 
		display: 'chart';
		morphicAct: [:text | GLMEyeSeeExamplesBrowser open ] icon: GLMUIThemeExtraIcons glamorousExample entitled: 'Browse basic examples'! !

!GLMEyeSeeEditor methodsFor: 'building' stamp: 'TudorGirba 10/8/2011 19:57'!
defaultTitle
	^ 'EyeSee Editor'! !

!GLMEyeSeeEditor methodsFor: 'building' stamp: 'TudorGirba 10/8/2011 19:56'!
resultIn: a
	^ a eyesee
		title: 'Chart';
		diagram: [ :renderer :bindings :script | 
			| context |
			context := GLMContext with: #chart -> renderer withAll: bindings.
			Compiler new evaluate: script in: context to: context ]! !

GLMScriptingEditorTemplate subclass: #GLMMondrianEasel
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Tools'!

!GLMMondrianEasel commentStamp: 'TudorGirba 12/28/2011 23:34' prior: 0!
This browser offers a Glamour-based MondrianEasel.

Example:
self openOn: {#variable->'value'}

This will open the editor with a variable named #variable whose value will be 'value'.!

!GLMMondrianEasel methodsFor: 'building' stamp: 'TudorGirba 10/8/2011 19:51'!
defaultScriptBindings
	^ {#view -> MOViewRenderer new}! !

!GLMMondrianEasel methodsFor: 'building' stamp: 'TudorGirba 10/8/2011 19:51'!
defaultScriptDisplayIn: aPresentation
	^ aPresentation display: 'view'! !

!GLMMondrianEasel methodsFor: 'building' stamp: 'TudorGirba 9/5/2011 19:04'!
defaultTitle
	^ 'Mondrian Easel'! !

!GLMMondrianEasel methodsFor: 'building' stamp: 'TudorGirba 6/2/2012 15:59'!
resultIn: a
	^ a mondrian
		title: 'Painting';
		painting: [ :view :bindings :script | 
			| context |
			context := GLMContext with: #view -> view withAll: bindings.
			Compiler new evaluate: script in: context to: context ];
		act: [ :m | m canvas exportAsPNG ] entitled: 'Export as PNG';
		act: [ :m | m canvas exportAsJPEG ] entitled: 'Export as JPEG';
		act: [ :m | m canvas exportAsSVG ] entitled: 'Export as SVG';
		act: [ :m | m canvas exportAsTikz ] entitled: 'Export as Tikz';
		act: [ :m | m canvas exportAsXML ] entitled: 'Export as XML';
		act: [ :m | 
					m canvas root decreaseZoom.
					m canvas changed ]
			icon: MondrianIcons mondrianZoomOut
			on: $-
			entitled: 'Zoom out';
		act: [ :m | 
					m canvas root increaseZoom.
					m canvas changed ]
			icon: MondrianIcons mondrianZoomIn
			on: $+
			entitled: 'Zoom in'! !

GLMScriptingEditorTemplate subclass: #GLMRoassalEasel
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Tools'!

!GLMRoassalEasel commentStamp: '<historical>' prior: 0!
This browser offers a Glamour-based Roassal Easel.

Example:
self openOn: {#variable->'value'}

This will open the editor with a variable named #variable whose value will be 'value'.!

!GLMRoassalEasel methodsFor: 'building' stamp: 'TudorGirba 6/5/2012 17:10'!
defaultScriptBindings
	^ {#view -> ROMondrianViewBuilder new}! !

!GLMRoassalEasel methodsFor: 'building' stamp: 'TudorGirba 9/9/2012 02:56'!
defaultScriptDisplayIn: aPresentation
	^ aPresentation 
		display: 'view';
		morphicAct: [:text | GLMRoassalExamplesBrowser open ] icon: GLMUIThemeExtraIcons glamorousExample entitled: 'Browse basic examples'! !

!GLMRoassalEasel methodsFor: 'building' stamp: 'TudorGirba 5/7/2012 10:18'!
defaultTitle
	^ 'Roassal Easel'! !

!GLMRoassalEasel methodsFor: 'building' stamp: 'TudorGirba 6/5/2012 17:13'!
resultIn: a
	^ a roassal
		title: 'View';
		painting: [ :view :bindings :script | 
			| context |
			context := GLMContext with: #view -> view withAll: bindings.
			Compiler new evaluate: script in: context to: context ];
		act: [ :roassal | 
			| fName |
			fName := UIManager default request:'Please enter the name' translated initialAnswer: self externalName,'.png'.
			fName isEmptyOrNil ifTrue:[^self].
			PNGReadWriter putForm: roassal bitmap onFileNamed: fName. ] entitled: 'Export as PNG';
		"act: [ :m | m canvas exportAsJPEG ] entitled: 'Export as JPEG';
		act: [ :m | m canvas exportAsSVG ] entitled: 'Export as SVG';"
		act: [ :roassal | ROZoomOutMove new on: roassal view container ]
			icon: MondrianIcons mondrianZoomOut
			entitled: 'Zoom out';
		act: [ :roassal | ROZoomInMove new on: roassal view container ]
			icon: MondrianIcons mondrianZoomIn
			entitled: 'Zoom in'! !

!GLMScriptingEditorTemplate classSide methodsFor: 'instance creation' stamp: 'TudorGirba 6/1/2012 20:09'!
open
	^ self openOn: {}! !

!GLMScriptingEditorTemplate classSide methodsFor: 'instance creation' stamp: 'TudorGirba 1/4/2012 08:08'!
openOn: anArrayOfAssociations
	"To spawn an editor, provide an array of associations whose values represent the names of a variables and the values are the objects referred by these variables. These variables can then be used in the code of the script.
	For example: 
	GLMEditor openOn: {#variable1->'value1' . #variable2->'value2'}"
	^ super openOn: anArrayOfAssociations! !

!GLMScriptingEditorTemplate methodsFor: 'building' stamp: 'TudorGirba 9/5/2011 19:05'!
buildBrowser
	browser := GLMTabulator new.
	self setTitleOf: browser.
	browser
		row: #result span: 2;
		row: [ :r | 
					r
						column: #script span: 3;
						column: #variables span: 2 ].
	browser transmit
		to: #script;
		andShow: [ :a | self scriptIn: a ].
	browser transmit
		to: #variables;
		andShow: [ :a | self variablesIn: a ].
	browser transmit
		to: #result;
		fromOutsidePort: #entity;
		from: #script;
		andShow: [ :a | self resultIn: a ].
	^ browser! !

!GLMScriptingEditorTemplate methodsFor: 'building' stamp: 'TudorGirba 10/8/2011 19:51'!
defaultScriptBindings
	"Override this method if you want to provide more bindings for your editor.
	Typically these bindings are related to the Facade that offers the entry point to the scripting API"
	^ {}! !

!GLMScriptingEditorTemplate methodsFor: 'building' stamp: 'TudorGirba 10/8/2011 19:51'!
defaultScriptDisplayIn: aPresentation
	^ ''! !

!GLMScriptingEditorTemplate methodsFor: 'building' stamp: 'TudorGirba 9/5/2011 19:06'!
defaultTitle
	^ 'Editor'! !

!GLMScriptingEditorTemplate methodsFor: 'building' stamp: 'TudorGirba 9/5/2011 18:55'!
resultIn: a
	"Override this method to describe the presentation that should show the result
	of evaluating the script"
	self subclassResponsibility ! !

!GLMScriptingEditorTemplate methodsFor: 'building' stamp: 'TudorGirba 5/24/2012 18:16'!
scriptIn: a
	^ a smalltalkCode
		title: 'Script';
		variableBindings: [ :bindings | 
					| col |
					col := OrderedCollection withAll: bindings.
					col addAll: self defaultScriptBindings.
					col ];
		with: [:p | self defaultScriptDisplayIn: p ];
		populate: #selection
			icon: GLMUIThemeExtraIcons glamorousPlay
			on: $s
			entitled: 'Generate'
			with: [ :text | text text ]
	";	act: [:text | text text ] icon: GLMUIThemeExtraIcons glamorousAccept entitled: 'Install'"! !

!GLMScriptingEditorTemplate methodsFor: 'building' stamp: 'TudorGirba 9/5/2011 19:05'!
setTitleOf:  b
	b title: self defaultTitle! !

!GLMScriptingEditorTemplate methodsFor: 'building' stamp: 'TudorGirba 11/15/2011 21:44'!
variablesIn: a
	^ a table
		selectionAct: [:t | t selection value inspect ] on: $i entitled: 'Inspect';
		selectionAct: [:t | t selection value explore ] on: $I entitled: 'Explore';		
		column: 'Variable' evaluated: [ :each | each key asString ];
		column: 'Value' evaluated: [ :each | each value asString contractTo: 20 ]! !

Object subclass: #GLMContext
	instanceVariableNames: 'variableBindings'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Tools'!

!GLMContext commentStamp: 'TudorGirba 8/24/2011 23:50' prior: 0!
This offers support for a do it context.

Example:
context := GLMContext withAll: {#a -> 1 . #b -> 2}.
Compiler new evaluate: 'a + b' in: context to: context!

!GLMContext classSide methodsFor: 'instance creation' stamp: 'TudorGirba 8/25/2011 00:03'!
with: aBinding withAll: aCollectionOfBindings
	| col |
	col := OrderedCollection with: aBinding.
	col addAll: aCollectionOfBindings.
	^ self withAll: col! !

!GLMContext classSide methodsFor: 'instance creation' stamp: 'TudorGirba 8/24/2011 23:48'!
withAll: aCollectionOfBindings
	^ self new variableBindings: (aCollectionOfBindings inject: Dictionary new into: [:dict :each | dict at: each key put: each value. dict])! !

!GLMContext methodsFor: 'bindings' stamp: 'TudorGirba 8/24/2011 23:36'!
bindingOf: aKey
	^ self variableBindings at: #aKey ifAbsent: [nil]! !

!GLMContext methodsFor: 'bindings' stamp: 'TudorGirba 8/24/2011 23:35'!
method 
	^ GLMContext >> #method! !

!GLMContext methodsFor: 'bindings' stamp: 'TudorGirba 8/24/2011 23:44'!
namedTempAt: index
	^ self variableBindings at: (self tempNames at: index)! !

!GLMContext methodsFor: 'bindings' stamp: 'TudorGirba 8/24/2011 23:43'!
tempNames
	^ self variableBindings keys asSortedCollection! !

!GLMContext methodsFor: 'accessing' stamp: 'TudorGirba 8/24/2011 23:36'!
variableBindings
	^ variableBindings! !

!GLMContext methodsFor: 'accessing' stamp: 'TudorGirba 8/24/2011 23:36'!
variableBindings: anObject
	variableBindings := anObject! !

Object subclass: #GLMOBCommandAdaptor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Tools'!

!GLMOBCommandAdaptor methodsFor: 'as yet unclassified' stamp: 'tg 9/25/2010 17:55'!
actionsFrom: aCollectionOfOBCommandClasses on: aTarget for: aRequestor
	^ (aCollectionOfOBCommandClasses "select: [ :each | each isActive ]") collect: [ :each |
		| command |
		command := each on: aTarget for: aRequestor.
		GLMGenericAction new
			icon: command icon;
			title: command label;
			action: [:presentation | command execute ];
			yourself 
		]! !
